import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Superclass of all enemies containing health, score, movement etc
 * 
 * @author Michael Garwood
 * @version 4/1/10
 */
public class Enemy  extends Actor
{

    protected int health;
    private int score;
    
    public Enemy(int thisHealth, int thisScore)
    {
        health = thisHealth;
        score = thisScore;
    }
    
    /**
     * Moves the enemy across the game field
     * @param x Change in x direction
     * @param y Chance in y direction
     */
    public void move(int x, int y)
    {
        setLocation(getX() + x, getY() + y);
    }
    
    public void hit()
    {
        health--;
    }
    
    public void die()
    {
        if(health <= 0)
        {
            getWorld().addObject(new ScoreBlip(Integer.toString(score)), getX(), getY());
            getWorld().removeObject(this);
        }
    }
    
    public void collide()
    {
        Actor player = getOneIntersectingObject(Player.class);
        if(player != null)
        {
            ((Player) player).harm();
        }
    }
}
