import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * HealthBoard controls the display of the player's lives on the screen
 * 
 * @author Michael Garwood
 * @version 4/1/10
 */
public class HealthBoard  extends Actor
{

    private Player player;
    private boolean exist = true;
    private int lastLives = 0;
    
    
    public HealthBoard(Player thisPlayer)
    {
        player = thisPlayer;
    }
    /**
     * Act - do whatever the HealthBoard wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkHealth();
    }    
    
    
    public void checkHealth()
    {
        int lives = ((Player) player).returnLives();
        if(lives != lastLives)
        {
            for(Object life : getWorld().getObjects(HealthDisplay.class))
            {
                ((HealthDisplay) life).remove();
            }

            int i = 1;
            int xPosition = 10;
            while(i <= lives)
            {
                getWorld().addObject(new HealthDisplay(), xPosition, 10);
                xPosition += 20;
                i++;
            }
                
        }
    }
}
