import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Spawns enemies randomly around the game field
 * 
 * @author Micahael Garwood
 * @version 5/1/10
 */
public class Spawner  extends Actor
{

    private int x;
    private int y;
    private int spinnerCountdown = 200;
    private int trackerCountdown = 1500;
    private int swarmerCountdown = 1000;
    /**
     * Act - do whatever the Spawner wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        spinnerCountdown();
        swarmerCountdown();
        trackerCountdown();
    }    
    
    /**
     * Spawns spinners
     */
    public void spinnerCountdown()
    {
        if(spinnerCountdown == 0)
        {
            int i = 1;
            while(i <= 2)
            {
                if(randomCoords())
                {
                    getWorld().addObject(new Spinner(), getX(), getY());
                    i++;
                }
            }
            spinnerCountdown = 350;
        }
        else
        {
            spinnerCountdown--;
        }     
    }
    
    /**
     * Spawns swarmers
     */
    public void swarmerCountdown()
    {
        if(swarmerCountdown == 0)
        {
            if(randomCoords())
            {
                int i = 0;
                while(i <= 0)
                {
                    getWorld().addObject(new Swarmer(), getX(), getY());
                    i++;
                }
            }
            swarmerCountdown = 1000;
        }
        else
        {
            swarmerCountdown--;
        }
    }
    
    /**
     * Spawns trackers
     */
    public void trackerCountdown()
    {
        if(trackerCountdown == 0)
        {
            for(int i = 1; i <= 2; i++)
            {
                if(randomCoords())
                {
                    getWorld().addObject(new Tracker(), getX(), getY());
                }
            }
            trackerCountdown = 1500;
        }
        else
        {
            trackerCountdown--;
        }
    }
    /**
     * Moves the spawner to the desired spawn location, checks to see if the player is in the
     * vicinity, and returns true if they are not, or false if they are
     */
    public boolean randomCoords()
    {
        x = Greenfoot.getRandomNumber(500);
        y = Greenfoot.getRandomNumber(500);
        setLocation(x, y);
        if(getOneObjectAtOffset(30, 30, Player.class) == null)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
}
