import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Spinner enemy. Moves around bouncing off the walls.
 * 
 * @author Michael Garwood
 * @version 4/1/10
 */
public class Spinner  extends Enemy
{

    private int deltaX;
    private int deltaY;

    public Spinner()
    {
        super(1, 50);
        deltaX = (Greenfoot.getRandomNumber(2) == 1)?3:-3;
        deltaY = (Greenfoot.getRandomNumber(2) == 1)?3:-3;
    }
    /**
     * Act - do whatever the Spinner wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        collide();
        setRotation(getRotation() + 2);
        bounceOffEdge();
        move(deltaX, deltaY);
        die();
    }    
    
    public void bounceOffEdge()
    {
        if(getX() == 0 || getX() == 499)
        {
            deltaX = -deltaX;
        }
        
        if(getY() == 0 || getY() == 499)
        {
            deltaY = -deltaY;
        }
    }
}
