import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Similar to the Swarmer, but moves depending on where the 'main'
 * Swarmer is and keeps around it in formation
 * 
 * @author Michael "Squirrels" Garwood 
 * @version 14/1/10
 */
public class Swarmlet  extends Enemy
{
    
    private int squadNum;
    private boolean burst = true;
    private Swarmer leader;

    public Swarmlet(int thisSquadNum, Swarmer thisLeader)
    {
        super(1, 20);
        squadNum = thisSquadNum;
        leader = thisLeader;
    }
        
    /**
     * Act - do whatever the Swarmlet wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        followLeader();
        collide();
        swarmletDie();
    }    
    
    /**
     * Follows the main Swarmer enemy in formation
     */
    public void followLeader()
    {
        int x = ((Swarmer) leader).returnX();
        int y = ((Swarmer) leader).returnY();
        
        if(squadNum == 1)
        {
            move(-getX() + (x - 5), -getY() + (y - 10));
        }
        
        if(squadNum == 2)
        {
            move(-getX() + (x + 5), -getY() + (y - 10));
        }
        
        if(squadNum == 3)
        {
            move(-getX() + (x + 10), -getY() + y);
        }
        
        if(squadNum == 4)
        {
            move(-getX() + (x + 5), -getY() + (y + 10));
        }
        
        if(squadNum == 5)
        {
            move(-getX() + (x - 5), -getY() + (y + 10));
        }
        
        if(squadNum == 6)
        {
            move(-getX() + (x - 10), -getY() + y);
        }
    }
    
    /**
     * Notifies the swarmer leader that it has lost a squad member when this 
     * swarmlet dies
     */
    public void swarmletDie()
    {
        if(health <= 0)
        {
            ((Swarmer) leader).swarmletHit();
            die();
        }
    }
}
