import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Vector World is here
 * 
 * @author Michael Garwood
 * @version 3/1/10
 */
public class VectorWorld  extends World
{
    private Player player = new Player();
    
    /**
     * Constructor for objects of class VectorWorld.
     */
    public VectorWorld()
    {    
        super(500, 500, 1); 
        setBackground("MenuBack.png");
        addObject(new StartButton(), 145, 385);
    }
    
    public int getPlayerX()
    {
        return player.getX();
    }
    
    public int getPlayerY()
    {
        return player.getY();
    }
    
    public void gameOver()
    {
        removeObjects(getObjects(Actor.class));
        setBackground("GameOver.png");
        addObject(new RetryButton(), 250, 350);
    }
    
    public void beginGame()
    {
        removeObjects(getObjects(Actor.class));
        addObject(player, 250, 250);
        addObject(new Spawner(), 0, 0);
        addObject(new HealthBoard(player), 0, 0);
        setBackground("GameBack.png");
    }
    
    public void restartGame()
    {
        setBackground("MenuBack.png");
        addObject(new StartButton(), 145, 385);
    }
}
